# Balloon Stomp
# By Roarribbit roarribbit@gmail.com
import random, pygame, sys, time, math, os.path
from pygame.locals import *

#CONSTANTS
WINDOWWIDTH = 960  # size of window's width in pixels
WINDOWHEIGHT = 540  # size of windows' height in pixels
WINDOWEDGE = 0
BALLOONWIDTH = 160
FASTESTRESPAWNCAP = 5  # don't let the balloons respawn faster than this many seconds

def addFade():  # this code makes the popped balloons fade away. Python bug prevented me from including this in function above
    global firstTime
    if firstTime == True:
        global fade
        fade = []
        firstTime = False
    fade.append(255)

def addBalloon():
    global redBalloon
    global poppedBool
    global fadeDone
    global randomSizedBalloonXList
    randomSize = random.uniform(0.5, 1.0)  # percentage to scale the balloons between 50% to 100%
    maxWidth = 160  # max width of red balloon
    maxHeight = 151  # max height of red balloon

    # randomize the balloon color
    randomBalloonNumber = random.randint(1, 3)
    balloonColor = redBalloon
    popBalloonColor = redBalloonPop
    if randomBalloonNumber == 1:  # put a red balloon if 1
        popBalloonColor = redBalloonPop
        balloonColor = redBalloon
        randomBalloonList.append(1)
    elif randomBalloonNumber == 2:  # put a blue balloon if 2
        popBalloonColor = blueBalloonPop
        balloonColor = blueBalloon
        randomBalloonList.append(2)
    elif randomBalloonNumber == 3:  # put a blue balloon if 3
        popBalloonColor = greenBalloonPop
        balloonColor = greenBalloon
        randomBalloonList.append(3)

    #add a scaled balloon to the table
    randomSizedBalloonX = math.trunc(maxWidth * randomSize)         # make a static variable to input into the pygame transform function
    randomSizedBalloonY = math.trunc(maxHeight * randomSize)
    randomSizedBalloonXList.append(randomSizedBalloonX)             # add the new size into a list to do collision detection later
    sizedRedBalloon = pygame.transform.scale(balloonColor, (randomSizedBalloonX, randomSizedBalloonY))  # scale the red balloon by randomSize
    balloons.append(sizedRedBalloon)  # add a balloon on the vendor

    # add a scaled pop balloon to the table
    sizedRedBalloonPopped = pygame.transform.scale(popBalloonColor, (math.trunc(163 * randomSize), math.trunc(165 * randomSize)))  # scale the red balloon by randomSize
    balloonPopped.append(sizedRedBalloonPopped)  # add a corresponding pop animation to list
    addFade()
    redBalloonX.append(960)  # add the new balloon on the right side of the screen
    randomY = random.randint(300, 325)  # random the vertical location of the balloon for variety
    redBalloonY.append(randomY)  # add the random Y to balloon location
    poppedBool.append(False)  # false means balloon hasn't been popped yet
    fadeDone.append(False)

def blit_alpha(target, source, location, opacity):
    x = location[0]
    y = location[1]
    temp = pygame.Surface((source.get_width(), source.get_height())).convert()
    temp.blit(target, (-x, -y))
    temp.blit(source, (0, 0))
    temp.set_alpha(opacity)
    target.blit(temp, location)

# set up Python window
FPS = 30  # frames per second, the general speed of the program
global FPSCLOCK, DISPLAYSURF
pygame.init()
FPSCLOCK = pygame.time.Clock()
DISPLAYSURF = pygame.display.set_mode((WINDOWWIDTH, WINDOWHEIGHT))
pygame.display.set_caption('BALLOON STOMP')
start_time = time.time()

#Text Variables
score = 0
scoreFont = pygame.font.Font('8bit.ttf', 15)
ruleFont = pygame.font.Font('8bit.ttf', 10)
titleFont = pygame.font.Font('8bit.ttf', 35)
spaceBarFont = pygame.font.Font('8bit.ttf', 30)
youdiditFont = pygame.font.Font('8bit.ttf', 20)
gameOverFont = pygame.font.Font('gameOverFont.otf',100)

#Sound Variables
popSound = pygame.mixer.Sound('pop.ogg')
gameOverSound = pygame.mixer.Sound('gameOver.ogg')
winningSound = pygame.mixer.Sound('youdidit.ogg')
pygame.mixer.music.load('titleMusic.ogg')
pygame.mixer.music.play(-1, 0.0)        # start the game music

#Vendor Variables
vendor1 = pygame.image.load('Vendor1.png')
vendor2 = pygame.image.load('Vendor2.png')
vendor3 = pygame.image.load('Vendor3.png')
vendor4 = pygame.image.load('Vendor4.png')
vendorAnimationFrame = (vendor1, vendor2, vendor3, vendor4)
vendorFrameCount = 0  # used to store current vendor animation frame
vendorAnimSpeedCount = 2  # used to track the animation speed by incrementing till the delay and looping again
BALLOONSPEED = 5  # speed balloons move to the left, increase to make them move faster
VENDORSPEED = 10  # used to say how long you want to delay each frame before switching, make sure the speed doesn't exceed delay
balloonSpeedCount = 0       # tracks how many loop iterations till we speed up the balloons
balloonSpeedUp = 50         # don't speed up balloons till program hits this many iterations

# Man Animation Variables
manwithboots = pygame.image.load('manwithboots.png')
manwithboots2 = pygame.image.load('manwithboots2.png')
manwithnoboots = pygame.image.load('manwithnoboots.png')
manAnimationFrame = (manwithboots, manwithboots2)
manFrameCount = 0
manAnimSpeedCount = 0
manSpeed = 15
shoeDropped = False
bootTracker = []
tempbootTracker = []

#Image and Balloon Variables
title = pygame.image.load('Title.png')
startGameFlag = False       # if this is True, then start the game and move everything, if it is False, then it should be showing the title only with the two buttons
bridge = pygame.image.load('Bridge.png')
doors = pygame.image.load('doors.png')
boot = pygame.image.load('boot.png')
global redBalloon
redBalloon = pygame.image.load('RedBalloon.png')
global blueBalloon
blueBalloon = pygame.image.load('BlueBalloon.png')
global greenBalloon
greenBalloon = pygame.image.load('GreenBalloon.png')
global balloons
balloons = []
global randomBalloonList
randomBalloonList = []
global redBalloonPop
redBalloonPop = pygame.image.load('RedBalloonPop.png')
global blueBalloonPop
blueBalloonPop = pygame.image.load('BlueBalloonPop.png')
global greenBalloonPop
greenBalloonPop = pygame.image.load('GreenBalloonPop.png')
global balloonPopped
balloonPopped = []
global fadeDone
fadeDone = []
global firstTime
firstTime = True
global randomSizedBalloonXList
randomSizedBalloonXList = []
tempballoons = []
tempballoonPopped = []
tempredBalloonX = []
tempredBalloonY = []
temppoppedBool = []
tempfade = []
temprandomBalloonList = []
tempfadeDone = []
temprandomSizedBalloonXList = []
gameOverCount = 10      # if this many red balloons pass game over
gameOverOpacity = 0     # the transparency of the red gameover rectangle
countedYet = False      # allows your gameOverCount to only count once per out of screen transaction
gameOverPlayed = False  # allows the gameOver sound to only play once
popThese = []
temppopThese = []
popCount = 0
highScoreCount = 0
offsetY = 150
playDidSound = False
displayHighScore = False
flashRed = False
flashRedOpacity = 100
flashBlue = False
flashBlueOpacity = 100
flashGreen = False
flashGreenOpacity = 100

#coordinates and speed variables
global redBalloonX
redBalloonX = []
global redBalloonY
redBalloonY = []
balblit = []  # used to track position of balloons for mouse clicks
global poppedBool  # boolean used to show popped balloon images
poppedBool = []
global fade

while True:  # main game loop
    DISPLAYSURF.fill((225, 225, 225))
    DISPLAYSURF.blit(vendorAnimationFrame[vendorFrameCount], (0, 0))
    DISPLAYSURF.blit(bridge, (0, 20))
    DISPLAYSURF.blit(doors, (0, 175))
    gameOverRect = pygame.Surface((WINDOWWIDTH,WINDOWHEIGHT))  # the size of your rect
    gameOverRect.set_alpha(gameOverOpacity)                # alpha level
    gameOverRect.fill((255,0,0))           # this fills the entire surface
    blueRect = pygame.Surface((WINDOWWIDTH,WINDOWHEIGHT))  # the size of your rect
    blueRect.set_alpha(flashBlueOpacity)                # alpha level
    blueRect.fill((0,0,255))           # this fills the entire surface
    greenRect = pygame.Surface((WINDOWWIDTH,WINDOWHEIGHT))  # the size of your rect
    greenRect.set_alpha(flashGreenOpacity)                # alpha level
    greenRect.fill((0,255,0))           # this fills the entire surface
    highScoreSurface = pygame.Surface((WINDOWWIDTH,WINDOWHEIGHT))  # the size of your rect
    highScoreSurface.fill((0,255,255))           # this fills the entire surface
    # TITLE TEXT
    titleSurfaceObj = titleFont.render('BALLOON STOMP', True, (0, 255, 0), (255, 0, 0))
    titleRectObj = titleSurfaceObj.get_rect()
    titleRectObj.topleft = (10, 10)
    DISPLAYSURF.blit(titleSurfaceObj, titleRectObj)
    # HIGHSCORE TEXT
    highScoreSurfaceObj = scoreFont.render('HIGH SCORE: ' + str(highScoreCount), True, (0, 0, 0), (225, 225, 225))
    highScoreRectObj = highScoreSurfaceObj.get_rect()
    highScoreRectObj.topleft = (620, 10+offsetY)
    DISPLAYSURF.blit(highScoreSurfaceObj, highScoreRectObj)
    # SCORE TEXT
    textSurfaceObj = scoreFont.render('SCORE: ' + str(score), True, (0, 0, 0), (225, 225, 225))
    textRectObj = textSurfaceObj.get_rect()
    textRectObj.topleft = (620, 35+offsetY)
    DISPLAYSURF.blit(textSurfaceObj, textRectObj)
    # REMAINING TRIES TEXT
    remainingBalloonsSurfaceObj = scoreFont.render('REMAINING BALLOONS: ' + str(gameOverCount), True, (0, 0, 0), (225, 225, 225))
    remainingBalloonsRectObj = remainingBalloonsSurfaceObj.get_rect()
    remainingBalloonsRectObj.topleft = (620, 60+offsetY)
    DISPLAYSURF.blit(remainingBalloonsSurfaceObj, remainingBalloonsRectObj)
    # SPACEBAR TEXT
    spaceBarSurfaceObj = spaceBarFont.render('PRESS SPACEBAR TO PLAY AGAIN', True, (0, 0, 0), (255, 155, 155))
    spaceBarRectObj = spaceBarSurfaceObj.get_rect()
    spaceBarRectObj.center = ((WINDOWWIDTH/2), WINDOWHEIGHT-100)
    # SPACEBAR STARTGAME TEXT
    clickFirstSurfaceObj = spaceBarFont.render('CLICK ANYWHERE OR', True, (0, 0, 0), (255, 155, 155))
    clickFirstRectObj = clickFirstSurfaceObj.get_rect()
    clickFirstRectObj.center = ((WINDOWWIDTH/2), WINDOWHEIGHT-100-20)
    # SPACEBAR STARTGAME TEXT
    spaceBarFirstSurfaceObj = spaceBarFont.render('PRESS SPACEBAR TO PLAY', True, (0, 0, 0), (255, 155, 155))
    spaceBarFirstRectObj = spaceBarFirstSurfaceObj.get_rect()
    spaceBarFirstRectObj.center = ((WINDOWWIDTH/2), WINDOWHEIGHT-50-20)
    # YOU GOT THE HIGH SCORE TEXT!
    youdiditSurfaceObj = youdiditFont.render('*** YOU GOT A HIGH SCORE OF ' + str(highScoreCount) + ' ***', True, (0, 255, 0), (255, 30, 30))
    youdiditRectObj = youdiditSurfaceObj.get_rect()
    youdiditRectObj.center = ((WINDOWWIDTH/2), 30)
    # GAMEOVER TEXT
    gameOverSurfaceObj = gameOverFont.render('GAMEOVER', True, (0, 0, 0), (255, 155, 155))
    gameOverRectObj = gameOverSurfaceObj.get_rect()
    gameOverRectObj.center = ((WINDOWWIDTH/2), WINDOWHEIGHT-335)
    # Rule 1
    rule1SurfaceObj = ruleFont.render('Don\'t stomp red balloons!', True, (0, 0, 0), (225, 225, 225))
    rule1RectObj = rule1SurfaceObj.get_rect()
    rule1RectObj.topleft = (5, 47+110)
    DISPLAYSURF.blit(rule1SurfaceObj, rule1RectObj)
    # Rule 2
    rule2SurfaceObj = ruleFont.render('Don\'t let green/blue balloons leave', True, (0, 0, 0), (225, 225, 225))
    rule2RectObj = rule2SurfaceObj.get_rect()
    rule2RectObj.topleft = (5, 60+110)
    DISPLAYSURF.blit(rule2SurfaceObj, rule2RectObj)
    # Rule 3
    rule3SurfaceObj = ruleFont.render('Stomp, Stomp, Stomp!', True, (0, 0, 0), (225, 225, 225))
    rule3RectObj = rule3SurfaceObj.get_rect()
    rule3RectObj.topleft = (5, 73+110)
    DISPLAYSURF.blit(rule3SurfaceObj, rule3RectObj)
    # Creds
    credsSurfaceObj = ruleFont.render('Created by: RoarRibbit - roarribbit@gmail.com', True, (0, 0, 0), (225, 225, 225))
    credsRectObj = credsSurfaceObj.get_rect()
    credsRectObj.center = ((WINDOWWIDTH/2), WINDOWHEIGHT-10)

    if startGameFlag == False:      # show the title screen
        DISPLAYSURF.blit(title, (0, 0))
        DISPLAYSURF.blit(blueBalloon, (175, 250-20))
        DISPLAYSURF.blit(greenBalloon, (600, 250-20))
        DISPLAYSURF.blit(redBalloon, (300, 250-20))
        DISPLAYSURF.blit(spaceBarFirstSurfaceObj, spaceBarFirstRectObj)
        DISPLAYSURF.blit(clickFirstSurfaceObj, clickFirstRectObj)
        DISPLAYSURF.blit(credsSurfaceObj, credsRectObj)
        for event in pygame.event.get():  # event handling loop
            if event.type == QUIT or (event.type == KEYUP and event.key == K_ESCAPE):
                popSound.stop()
                pygame.mixer.music.stop()
                file = open("data", "w")
                file.write(str(highScoreCount))
                file.close()
                pygame.quit()
                sys.exit()
            elif event.type == MOUSEBUTTONDOWN:  # if the mouse button was clicked
                if event.button == 1:
                    startGameFlag = True
                    popSound.play()
                    startGameFlag = True
                    pygame.mixer.music.load('gameMusic.ogg')
                    pygame.mixer.music.play(-1, 0.0)        # start the game music
                    # load high score
                    if os.path.isfile("data"):
                        file = open("data", "r")
                        highScoreCount = int(file.read())
                        file.close()
                    addBalloon()  # add the first balloon
            elif event.type == KEYUP and event.key == K_SPACE:
                startGameFlag = True
                popSound.play()
                startGameFlag = True
                pygame.mixer.music.load('gameMusic.ogg')
                pygame.mixer.music.play(-1, 0.0)        # start the game music
                # load high score
                if os.path.isfile("data"):
                    file = open("data", "r")
                    highScoreCount = int(file.read())
                    file.close()
                addBalloon()  # add the first balloon
    else:       # start the game
        # draw the man
        if shoeDropped == False:
            DISPLAYSURF.blit(manAnimationFrame[manFrameCount], (350, 85))
            if manAnimSpeedCount < manSpeed:  # if manAnimSpeedCount is less than 10, don't increase the frame count
                manAnimSpeedCount += 1
            elif manAnimSpeedCount >= manSpeed:
                if manFrameCount < 1:  # if frame is less than 1 increase frame count by 1
                    manFrameCount += 1
                elif manFrameCount >= 1:  # if frame count is 1 then loop back to frame 0 to make it look like it's moving
                    manFrameCount = 0
                manAnimSpeedCount = 0

        for i in range(0, len(balloons)):
            if (redBalloonX[i] <= WINDOWWIDTH):  # if balloon is to the left of the max window size
                if (redBalloonX[i] + BALLOONWIDTH) > WINDOWEDGE:  # if the balloon is larger than the left window limit draw the balloon
                    if poppedBool[i] == False:  # if a balloon is shown as False, it is not popped, therefore display it
                        balblit.insert(i, DISPLAYSURF.blit(balloons[i], (redBalloonX[i], redBalloonY[i])))  # show to screen and put in blitz to capture rect for collision
                        tempballoons.append(balloons[i])     # if it's not popped, put all unpopped balloons into fresh array
                        tempballoonPopped.append(balloonPopped[i])
                        tempfade.append(fade[i])
                        temppoppedBool.append(poppedBool[i])
                        temprandomBalloonList.append(randomBalloonList[i])
                        tempredBalloonX.append(redBalloonX[i])
                        tempredBalloonY.append(redBalloonY[i])
                        tempfadeDone.append(fadeDone[i])
                        temprandomSizedBalloonXList.append(randomSizedBalloonXList[i])
                    else:
                        balblit.insert(i, DISPLAYSURF.blit(balloons[i], (-BALLOONWIDTH, 0)))  #if it's already popped, move the invisible rect out of the screen
                elif (redBalloonX[i] + randomSizedBalloonXList[i]) < WINDOWEDGE:        # if balloon is out of the window on the left side
                    if randomBalloonList[i] == 2:  # if balloon is blue or green color and goes out the window, take away points till gameover
                        if countedYet == False:
                            gameOverCount-=1
                            flashBlue = True
                            countedYet = True
                    if randomBalloonList[i] == 3:  # if balloon is blue or green color and goes out the window, take away points till gameover
                        if countedYet == False:
                            gameOverCount-=1
                            flashGreen = True
                            countedYet = True
        countedYet = False  # allow us to be able to subtract more from gameOverCount
        balloons = tempballoons             # copy the fresh array back to original array to get rid of "Nones" or popped balloons, thus, ridding of all popped balloons from vendor
        balloonPopped = tempballoonPopped
        fade = tempfade
        poppedBool = temppoppedBool
        randomBalloonList = temprandomBalloonList
        redBalloonY = tempredBalloonY
        redBalloonX = tempredBalloonX
        fadeDone = tempfadeDone
        randomSizedBalloonXList = temprandomSizedBalloonXList
        temprandomSizedBalloonXList = []
        tempballoons = []
        tempballoonPopped = []
        tempfade = []
        temppoppedBool = []
        temprandomBalloonList = []
        tempredBalloonY = []
        tempredBalloonX = []
        tempfadeDone = []

        for event in pygame.event.get():  # event handling loop
            if event.type == QUIT or (event.type == KEYUP and event.key == K_ESCAPE):
                popSound.stop()
                pygame.mixer.music.stop()
                file = open("data", "w")
                file.write(str(highScoreCount))
                file.close()
                pygame.quit()
                sys.exit()
            elif event.type == MOUSEBUTTONDOWN:  # if the mouse button was clicked
                if event.button == 1:
                    if gameOverCount > 0:
                        pos = pygame.mouse.get_pos()  #get the mouse x,y
                        for z in range(0, len(balloons)):  # look through all current balloons, subtract 1 so it doesn't loop to the actual numerical max since we count the zero as first element
                            if balblit[z].collidepoint(pos):  # if a balloon collides with mouse do something
                                popSound.play()
                                if (BALLOONSPEED < 20):  # increase balloon movement speed each time you pop one
                                    BALLOONSPEED += 0.5
                                if VENDORSPEED > 0.5:  # increase vendor speed each time you pop one
                                    VENDORSPEED -= 0.3
                                if balloonSpeedUp > FASTESTRESPAWNCAP:  # speed the balloons are respawning when user clicks one
                                    balloonSpeedUp -= 2
                                if randomBalloonList[z] == 1:  # if balloon is red color, subtract points
                                    score -= 25
                                    gameOverCount-=1
                                    flashRed = True
                                else:  # if balloon is green or blue, add points
                                    score += 10
                                poppedBool[z] = True
                                shoeDropped = True
                                popThese.append([])
                                popThese[popCount].append(balloonPopped[z])   # capture poppedBalloonPic, X, Y, fade
                                popThese[popCount].append(redBalloonX[z])
                                popThese[popCount].append(redBalloonY[z])
                                popThese[popCount].append(fade[z])
                                bootTracker.append([])
                                bootTracker[popCount].append(redBalloonX[z])
                                bootTracker[popCount].append(redBalloonY[z]-10)
                                popCount+=1
            elif event.type == KEYDOWN and event.key == K_TAB:
                FPS = 200000
            elif event.type == KEYUP and event.key == K_TAB:
                FPS = 30
            elif event.type == KEYUP and event.key == K_SPACE and gameOverCount <= 0:
                score = 0
                BALLOONSPEED = 5  # speed balloons move to the left, increase to make them move faster
                VENDORSPEED = 10  # used to say how long you want to delay each frame before switching, make sure the speed doesn't exceed delay
                balloonSpeedCount = 0       # tracks how many loop iterations till we speed up the balloons
                balloonSpeedUp = 50         # don't speed up balloons till program hits this many iterations
                balloons = []
                randomBalloonList = []
                fadeDone = []
                balloonPopped = []
                firstTime = True
                randomSizedBalloonXList = []
                tempballoons = []
                tempballoonPopped = []
                tempredBalloonX = []
                tempredBalloonY = []
                temppoppedBool = []
                tempfade = []
                temprandomBalloonList = []
                tempfadeDone = []
                temprandomSizedBalloonXList = []
                gameOverCount = 10      # if this many red balloons pass game over
                gameOverOpacity = 0     # the transparency of the red gameover rectangle
                countedYet = False      # allows your gameOverCount to only count once per out of screen transaction
                gameOverPlayed = False  # allows the gameOver sound to only play once
                redBalloonX = []
                redBalloonY = []
                balblit = []  # used to track position of balloons for mouse clicks
                poppedBool = []
                popCount = 0
                popThese = []
                playDidSound = False
                flashRed = False
                flashRedOpacity = 100
                flashBlue = False
                flashBlueOpacity = 100
                flashGreen = False
                flashGreenOpacity = 100
                gameOverRect.set_alpha(gameOverOpacity)                # alpha level
                addBalloon()
                pygame.mixer.music.play(-1, 0)

        if flashRed == True:
            # flash screen red when we hit the wrong balloon
            gameOverRect.set_alpha(flashRedOpacity)                # alpha level
            DISPLAYSURF.blit(gameOverRect, (0,0))    # (0,0) are the top-left coordinates
            if flashRedOpacity < 255:
                flashRedOpacity+=50
            else:
                flashRed = False
                flashRedOpacity = 100

        if flashBlue == True:
            # flash screen blue when blue balloon leaves the screen
            blueRect.set_alpha(flashBlueOpacity)
            DISPLAYSURF.blit(blueRect, (0, 0))
            if flashBlueOpacity < 255:
                flashBlueOpacity+=50
            else:
                flashBlue = False
                flashBlueOpacity = 100

        if flashGreen == True:
            # flash screen blue when blue balloon leaves the screen
            greenRect.set_alpha(flashGreenOpacity)
            DISPLAYSURF.blit(greenRect, (0, 0))
            if flashGreenOpacity < 255:
                flashGreenOpacity+=50
            else:
                flashGreen = False
                flashGreenOpacity = 100

        for i in range(0, popCount):  # show popped balloon images for all balloons that have been clicked
            if popThese[i][3] <= 0:
                popCount-=1
                shoeDropped = False
            if popThese[i][3] > 0:           # if the opacity is still visible, keep fading it and rising the popped image
                DISPLAYSURF.blit(manwithnoboots, (350, 100))
                blit_alpha(DISPLAYSURF, boot, (bootTracker[i][0], bootTracker[i][1]), popThese[i][3])
                blit_alpha(DISPLAYSURF, popThese[i][0], (popThese[i][1], popThese[i][2] - 20), popThese[i][3])
                popThese[i][1] += 2  # make the popped image jump forward a little to the right
                popThese[i][2] -= 5  # make the popped image rise up slowly
                popThese[i][3] -= 25  # how fast the popped balloons fade
                temppopThese.append(popThese[i])
                tempbootTracker.append(bootTracker[i])
        popThese = temppopThese
        bootTracker = tempbootTracker
        temppopThese = []
        tempbootTracker = []

        # make GameOver status
        if(gameOverCount<=0):
            gameOverRect.set_alpha(gameOverOpacity)                # alpha level
            DISPLAYSURF.blit(gameOverRect, (0,0))    # (0,0) are the top-left coordinates
            DISPLAYSURF.blit(spaceBarSurfaceObj, spaceBarRectObj)
            DISPLAYSURF.blit(gameOverSurfaceObj, gameOverRectObj)
            if highScoreCount < score:
                highScoreCount = score
                playDidSound = True
            if playDidSound == True:
                DISPLAYSURF.blit(youdiditSurfaceObj, youdiditRectObj)
            if gameOverPlayed == False:
                gameOverSound.play()
                if playDidSound == True:
                    winningSound.play()
                pygame.mixer.music.stop()
                gameOverPlayed = True
            if gameOverOpacity < 200:
                gameOverOpacity+=8

        # Animate the balloons to go to the left
        for i in range(0, len(balloons)):
             # Game over if count is higher than 10
            if gameOverCount > 0:
                redBalloonX[i] -= BALLOONSPEED

        # vendorAnimSpeed slows down the rate at which each frame switches to another frame, thereby slowing down the vendor
        if vendorAnimSpeedCount < VENDORSPEED:  # if vendorAnimSpeed is less than 10, don't increase the frame count
            vendorAnimSpeedCount += 1
        elif vendorAnimSpeedCount >= VENDORSPEED and gameOverCount > 0:
            if vendorFrameCount < 3:  # if frame is less than 3 increase frame count by 1
                vendorFrameCount += 1
            elif vendorFrameCount >= 3:  # if frame count is 4 then loop back to frame 0 to make it look like it's moving
                vendorFrameCount = 0
            vendorAnimSpeedCount = 0

        if balloonSpeedCount < balloonSpeedUp:      # add balloons every balloonSpeedUp iteration of the game loop
            balloonSpeedCount += 1      # delay another loop till balloon add
        else:
            if gameOverCount > 0:       # if the game is still going, no game over, keep adding balloons
                addBalloon()            #add balloon
                balloonSpeedCount = 0   # reset the add count till another iteration

    # Redraw the screen and wait a clock tick.
    pygame.display.update()
    FPSCLOCK.tick(FPS)
